org.apache.http.nio.protocol

## Class AsyncNHttpServiceHandler

- java.lang.Object
- - org.apache.http.nio.protocol.NHttpHandlerBase
  - - org.apache.http.nio.protocol.AsyncNHttpServiceHandler

- All Implemented Interfaces:
    NHttpServiceHandler

  Deprecated.
  (4.2) use `HttpAsyncService`

      @Deprecated
      @Immutable
      public class AsyncNHttpServiceHandler
      extends NHttpHandlerBase
      implements NHttpServiceHandler

  Fully asynchronous HTTP server side protocol handler implementation that implements the essential requirements of the HTTP protocol for the server side message processing as described by RFC 2616. It is capable of processing HTTP requests with nearly constant memory footprint. Only HTTP message heads are stored in memory, while content of message bodies is streamed directly from the entity to the underlying channel (and vice versa) `ConsumingNHttpEntity` and `ProducingNHttpEntity` interfaces.

  When using this class, it is important to ensure that entities supplied for writing implement `ProducingNHttpEntity`. Doing so will allow the entity to be written out asynchronously. If entities supplied for writing do not implement `ProducingNHttpEntity`, a delegate is added that buffers the entire contents in memory. Additionally, the buffering might take place in the I/O thread, which could cause I/O to block temporarily. For best results, ensure that all entities set on `HttpResponse`s from `NHttpRequestHandler`s implement `ProducingNHttpEntity`.

  If incoming requests enclose a content entity, `NHttpRequestHandler`s are expected to return a `ConsumingNHttpEntity` for reading the content. After the entity is finished reading the data, `NHttpRequestHandler.handle(HttpRequest, HttpResponse, NHttpResponseTrigger, HttpContext)` is called to generate a response.

  Individual `NHttpRequestHandler`s do not have to submit a response immediately. They can defer transmission of the HTTP response back to the client without blocking the I/O thread and to delegate the processing the HTTP request to a worker thread. The worker thread in its turn can use an instance of `NHttpResponseTrigger` passed as a parameter to submit a response as at a later point of time once the response becomes available.
  Since:
    4.0

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `AsyncNHttpServiceHandler.ServerConnState` Deprecated.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected HttpExpectationVerifier` | `expectationVerifier` Deprecated.
    `protected NHttpRequestHandlerResolver` | `handlerResolver` Deprecated.
    `protected HttpResponseFactory` | `responseFactory` Deprecated.

    - ### Fields inherited from class org.apache.http.nio.protocol.NHttpHandlerBase

      `allocator, CONN_STATE, connStrategy, eventListener, httpProcessor, params`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AsyncNHttpServiceHandler(HttpProcessor httpProcessor, HttpResponseFactory responseFactory, ConnectionReuseStrategy connStrategy, ByteBufferAllocator allocator, HttpParams params)` Deprecated.
    `AsyncNHttpServiceHandler(HttpProcessor httpProcessor, HttpResponseFactory responseFactory, ConnectionReuseStrategy connStrategy, HttpParams params)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closed(NHttpServerConnection conn)` Deprecated. Triggered when the connection is closed.
    `void` | `connected(NHttpServerConnection conn)` Deprecated. Triggered when a new incoming connection is created.
    `void` | `exception(NHttpServerConnection conn, HttpException httpex)` Deprecated. Triggered when an HTTP protocol violation occurs while receiving an HTTP request.
    `void` | `exception(NHttpServerConnection conn, IOException ex)` Deprecated. Triggered when an I/O error occurs while reading from or writing to the underlying channel.
    `void` | `inputReady(NHttpServerConnection conn, ContentDecoder decoder)` Deprecated. Triggered when the underlying channel is ready for reading a new portion of the request entity through the corresponding content decoder.
    `void` | `outputReady(NHttpServerConnection conn, ContentEncoder encoder)` Deprecated. Triggered when the underlying channel is ready for writing a next portion of the response entity through the corresponding content encoder.
    `void` | `requestReceived(NHttpServerConnection conn)` Deprecated. Triggered when a new HTTP request is received.
    `protected void` | `responseComplete(HttpResponse response, HttpContext context)` Deprecated. Signals that this response has been fully sent.
    `void` | `responseReady(NHttpServerConnection conn)` Deprecated. Triggered when the connection is ready to accept a new HTTP response.
    `void` | `setExpectationVerifier(HttpExpectationVerifier expectationVerifier)` Deprecated.
    `void` | `setHandlerResolver(NHttpRequestHandlerResolver handlerResolver)` Deprecated.
    `void` | `timeout(NHttpServerConnection conn)` Deprecated. Triggered when no input is detected on this connection over the maximum period of inactivity.

    - ### Methods inherited from class org.apache.http.nio.protocol.NHttpHandlerBase

      `canResponseHaveBody, closeConnection, getParams, handleTimeout, setEventListener, shutdownConnection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### responseFactory

          protected final HttpResponseFactory responseFactory

      Deprecated.

    - #### handlerResolver

          protected NHttpRequestHandlerResolver handlerResolver

      Deprecated.

    - #### expectationVerifier

          protected HttpExpectationVerifier expectationVerifier

      Deprecated.

  - ### Constructor Detail

    - #### AsyncNHttpServiceHandler

          public AsyncNHttpServiceHandler(HttpProcessor httpProcessor,
                                  HttpResponseFactory responseFactory,
                                  ConnectionReuseStrategy connStrategy,
                                  ByteBufferAllocator allocator,
                                  HttpParams params)

      Deprecated.

    - #### AsyncNHttpServiceHandler

          public AsyncNHttpServiceHandler(HttpProcessor httpProcessor,
                                  HttpResponseFactory responseFactory,
                                  ConnectionReuseStrategy connStrategy,
                                  HttpParams params)

      Deprecated.

  - ### Method Detail

    - #### setExpectationVerifier

          public void setExpectationVerifier(HttpExpectationVerifier expectationVerifier)

      Deprecated.

    - #### setHandlerResolver

          public void setHandlerResolver(NHttpRequestHandlerResolver handlerResolver)

      Deprecated.

    - #### connected

          public void connected(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when a new incoming connection is created.
      Specified by:
        `connected` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - new incoming connection HTTP connection.

    - #### requestReceived

          public void requestReceived(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when a new HTTP request is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP request object.

      If the request received encloses a request entity this method will be followed a series of `NHttpServiceHandler.inputReady(NHttpServerConnection, ContentDecoder)` calls to transfer the request content.
      Specified by:
        `requestReceived` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that contains a new HTTP request
      See Also:
        `NHttpServerConnection`

    - #### closed

          public void closed(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the connection is closed.
      Specified by:
        `closed` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - closed HTTP connection.

    - #### exception

          public void exception(NHttpServerConnection conn,
                       HttpException httpex)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when an HTTP protocol violation occurs while receiving an HTTP request.
      Specified by:
        `exception` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that caused an HTTP protocol violation
        `httpex` - HTTP protocol violation exception

    - #### exception

          public void exception(NHttpServerConnection conn,
                       IOException ex)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when an I/O error occurs while reading from or writing to the underlying channel.
      Specified by:
        `exception` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that caused an I/O error
        `ex` - I/O exception

    - #### timeout

          public void timeout(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when no input is detected on this connection over the maximum period of inactivity.
      Specified by:
        `timeout` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that caused timeout condition.

    - #### inputReady

          public void inputReady(NHttpServerConnection conn,
                        ContentDecoder decoder)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the underlying channel is ready for reading a new portion of the request entity through the corresponding content decoder.

      If the content consumer is unable to process the incoming content, input event notifications can be temporarily suspended using `IOControl` interface.
      Specified by:
        `inputReady` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that can produce a new portion of the incoming request content.
        `decoder` - The content decoder to use to read content.
      See Also:
        `NHttpServerConnection`, `ContentDecoder`, `IOControl`

    - #### responseReady

          public void responseReady(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the connection is ready to accept a new HTTP response. The protocol handler does not have to submit a response if it is not ready.
      Specified by:
        `responseReady` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that contains an HTTP response
      See Also:
        `NHttpServerConnection`

    - #### outputReady

          public void outputReady(NHttpServerConnection conn,
                         ContentEncoder encoder)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the underlying channel is ready for writing a next portion of the response entity through the corresponding content encoder.

      If the content producer is unable to generate the outgoing content, output event notifications can be temporarily suspended using `IOControl` interface.
      Specified by:
        `outputReady` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that can accommodate a new portion of the outgoing response content.
        `encoder` - The content encoder to use to write content.
      See Also:
        `NHttpServerConnection`, `ContentEncoder`, `IOControl`

    - #### responseComplete

          protected void responseComplete(HttpResponse response,
                              HttpContext context)

      Deprecated.
      Signals that this response has been fully sent. This will be called after submitting the response to a connection, if there is no entity in the response. If there is an entity, it will be called after the entity has completed.

Copyright © 2005–2013 The Apache Software Foundation. All rights reserved.